if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[sp_DivisionLoad]') and xtype = N'P')
drop procedure [dbo].[sp_DivisionLoad]
GO
create procedure dbo.sp_DivisionLoad @x xml
 ,@FileID uniqueidentifier = null
 ,@Worker uniqueidentifier = null
as
begin
SELECT 
   T.c.value('./MO[1]', 'varchar(6)') AS MO
  ,T.c.value('./TYPE[1]', 'varchar(6)') AS [TYPE]
INTO #ZGLV
FROM @x.nodes('DIVISION//header') T(c)

SELECT 
  T.c.value('./BR_CODE[1]', 'varchar(17)') AS BR_CODE
 ,T.c.value('./CODE[1]', 'varchar(16)') AS CODE
 ,T.c.value('./NAME[1]', 'varchar(128)') AS NAME
 ,T.c.value('./FULLNAME[1]', 'varchar(255)') AS FULLNAME
 ,T.c.value('./ADDRESS[1]', 'varchar(255)') AS [ADDRESS]
 ,T.c.value('./DIVISION_TYPE[1]', 'int') AS DIVISION_TYPE
 ,T.c.value('./ACTIVE[1]', 'int') AS ACTIVE

INTO #ZAP
FROM @x.nodes('DIVISION//body') T(c)


alter table #ZAP add DivisionID uniqueidentifier
alter table #ZAP add BranchID uniqueidentifier

create table #Errors
(
	CODE int,
	COMMENT varchar(250)
)

insert into #Errors
select 1, 'МО не найдена'
from #ZGLV zglv
where not exists(select* from iszl.t_f003 lm where lm.mcod = zglv.MO)

-- поиск отделения и филиала
update zap
set DivisionID = ( select top 1 div.DivisionID 
					from iszl.T_DIVISION div 
						left join iszl.T_BRANCH br on div.Branch = br.BranchID 
					where div.CODE = zap.CODE
						and (div.LpuMain=zglv.MO OR br.F003Mo=zglv.MO) )
	,BranchID = (select top 1 br.BranchID from iszl.T_BRANCH br where br.BR_CODE=zap.BR_CODE and br.F003Mo=zglv.MO)
	
from #ZAP zap
	outer apply #ZGLV zglv

--select* from #ZGLV
--select * from #ZAP zap
--select* from #Errors

--DROP TABLE #ZGLV
--DROP TABLE #ZAP
--DROP TABLE #Errors

declare @type varchar(6)
set @type = (select zglv.[TYPE] from #ZGLV zglv)

if (@type <> 'Insert' and @type <> 'Update' and @type <> 'Delete')
begin
	insert into #Errors (CODE,COMMENT)
	select 4, 'Неверный тип операции.'
end

if(@type = 'Insert')
begin
	-- нельзя удалять, тк могут быть профили коек в отделении
	-- удаляем, если есть
	--delete t from [ISZL].[T_DIVISION] t
	--join #ZAP zap on t.DivisionID = zap.DivisionID
	insert into #Errors (CODE,COMMENT)
	select 2, 'Отделение было добавлено ранее' 
	from #ZAP
	where DivisionID is not null

	-- вставка, если нет ошибок
	INSERT INTO [ISZL].[T_DIVISION]([DivisionID],[NAME],[CODE],[FULLNAME],[ADDRESS],[ACTIVE],[Branch],[V006MedicalTerms],[BR_CODE],[LpuMain])
	select NEWID()
		,zap.NAME
		,zap.CODE
		,zap.FULLNAME
		,zap.[ADDRESS]
		,zap.ACTIVE
		,zap.BranchID
		,zap.DIVISION_TYPE
		,zap.BR_CODE
		,case when zap.BranchID is null then zglv.MO else null end
	from #ZAP zap, #ZGLV zglv
	where (select COUNT(*) from #Errors) = 0
end

if(@type = 'Update')
begin
	UPDATE t
	   SET [NAME] = zap.NAME
		  ,[CODE] = zap.CODE
		  ,[FULLNAME] = zap.FULLNAME
		  ,[ADDRESS] = zap.[ADDRESS]
		  ,[ACTIVE] = (case when zap.ACTIVE = 0 then 0 else 1 end)
		  ,[Branch] = zap.BranchID
		  ,[V006MedicalTerms] = zap.DIVISION_TYPE
		  ,[BR_CODE] = zap.BR_CODE
		  ,[LpuMain] = case when zap.BranchID is null then zglv.MO else null end
	from [ISZL].[T_DIVISION] t, #ZAP zap, #ZGLV zglv
	WHERE (select COUNT(*) from #Errors) = 0 and t.DivisionID = zap.DivisionID

	-- вставка, если не найдена
	INSERT INTO [ISZL].[T_DIVISION]([DivisionID],[NAME],[CODE],[FULLNAME],[ADDRESS],[ACTIVE],[Branch],[V006MedicalTerms],[BR_CODE],[LpuMain])
	select NEWID()
		,zap.NAME
		,zap.CODE
		,zap.FULLNAME
		,zap.[ADDRESS]
		,zap.ACTIVE
		,zap.BranchID
		,zap.DIVISION_TYPE
		,zap.BR_CODE
		,case when zap.BranchID is null then zglv.MO else null end
	from #ZAP zap, #ZGLV zglv
	where (select COUNT(*) from #Errors) = 0 and zap.DivisionID is null
end

if(@type = 'Delete')
begin

	insert into #Errors
	select 3, 'Запись не найдена в ранее загруженных списках'
	from #ZAP zap
	where zap.DivisionID is null

	delete t
	from [ISZL].[T_DIVISION] t, #ZAP zap
	WHERE (select COUNT(*) from #Errors) = 0 and t.DivisionID = zap.DivisionID

end

select (case 
	   when (select COUNT(*) from #Errors) = 0 
	   then cast(1 as bit)
	   else case
			when (select COUNT(*) from #Errors) > 0
			then cast(0 as bit)
			end
	   end),
	   '<?xml version="1.0" encoding="Windows-1251"?>' 
		+ 
		(
			SELECT 
				CODE as 'CODE'
				,COMMENT as 'COMMENT'
			FROM #Errors 
			FOR XML PATH('ERR'),ROOT('ROOT')
		)
DROP TABLE #ZGLV
DROP TABLE #ZAP
DROP TABLE #Errors
end
